#include <bits/stdc++.h>
//#include <windows.h>

#define bug cout<<"bug "<<__LINE__<<endl
#define index xedni
//#define int long long

const int inf=1e9+7;
const int MOD=1e9+7;
const int MAXN=50;

using namespace std;

int n, m;
int g[MAXN][MAXN], visited[MAXN][MAXN];
int sx, sy, tx, ty;

int kx[4] = {0, 0, 1, -1};
int ky[4] = {1, -1, 0, 0};

void Dfs(int x, int y, int mjleft) {
    if(x == tx && y == ty) {
        cout << "Y" << endl;
        exit(0);
    }
    visited[x][y] = true;
    for(int k = 0; k <= 3; k++) {
        int newx = x + kx[k];
        int newy = y + ky[k];
        if(newx < 1 || newy < 1 || newx > n || newy > m) {
            continue;
        }
        if(g[newx][newy] == 1) {
            continue;
        }
        if(visited[newx][newy]) {
            continue;
        }
        if(g[newx][newy] == 4) {
            if(mjleft) {
                Dfs(newx, newy, mjleft - 1);
            }
        } else {
            Dfs(newx, newy, mjleft);
        }
    }
}

signed main() {
//	freopen(".in", "r", stdin);
//	freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cin >> g[i][j];
            if(g[i][j] == 2) {
                sx = i, sy = j;
            } else if (g[i][j] == 3) {
                tx = i, ty = j;
            }
        }
    }

    Dfs(sx, sy, 5);

    cout << "N" << endl;

    return 0;
}